<?php

namespace Drupal\ldap_auth\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\ldap_auth\MiniorangeLdapSupport;
use Drupal\ldap_auth\Utilities;
use Drupal\Core\Render\Markup;

/**
 *
 */
class MiniorangeLicensing extends LDAPFormBase {

  /**
   *
   */
  public function getFormId() {
    return 'miniorange_ldap_licensing';
  }

  /**
   *
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    global $base_url;

    $form['markup_library'] = [
      '#attached' => [
        'library' => [
          "ldap_auth/ldap_auth.admin",
          "ldap_auth/ldap_auth.style_settings",
          "ldap_auth/ldap_auth.main",

        ],
      ],
    ];
    $this->config_factory->set('miniorange_ldap_license_page_visited', "True")->save();
    $refer = $base_url . '/admin/config/people/ldap_auth/ldap_config';

    $form['markup_1'] = [
      '#markup' => $this->t('<div class="mo_ldap_licensing_table_layout">
            <div class="mo_ldap_license_layout"><br>'),
    ];

    $form['heading'] = [
        "#markup" => $this->t('<h2 style="text-align: center;"><a href=' . $refer . ' class="button button--danger" style="float:left;">&#11164;&nbsp;BACK</a>Active Directory / LDAP Integration <br> Licensing Plans</h2><br>'),
    ];


    $module_path = $this->moduleList->getPath("ldap_auth");
    $miniorangeBaseUrl = "https://login.xecurify.com/moas/login?redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=";


    $standard = Markup::create(t('<a class="button button--small js-form-submit form-submit use-ajax mo_top_bar_button" data-dialog-options="{&quot;width&quot;:&quot;40%&quot;}" 
            data-dialog-type="modal" href="requestTrial" >Try it free</a><br><a class="button button--primary button--small" target="_blank" href= "'.$miniorangeBaseUrl.'=drupal8_ldap_standard_plan">Upgrade Now</a>')) ;
    $premium = Markup::create(t('<a class="button button--small js-form-submit form-submit use-ajax mo_top_bar_button" data-dialog-options="{&quot;width&quot;:&quot;40%&quot;}" 
            data-dialog-type="modal" href="requestTrial" >Try it free</a><br><a class="button button--primary button--small" target="_blank" href="'.$miniorangeBaseUrl.'drupal8_ldap_premium_plan">Upgrade Now</a>'));
    $allincluisve  = Markup::create(t('<a class="button button--small js-form-submit form-submit use-ajax mo_top_bar_button" data-dialog-options="{&quot;width&quot;:&quot;40%&quot;}" 
            data-dialog-type="modal" href="requestTrial" >Try it free</a><br><a class="button button--primary button--small" target="_blank" href="https://www.miniorange.com/contact">Contact Us</a>'));


    $features = [
          [ Markup::create(t('<h3>FEATURES</h3>')), Markup::create(t('<br><h2>FREE</h2> <p class="mo_ldap_pricing-rate"><sup>$</sup> 0</p>')), Markup::create(t("<br><h2>STANDARD</h2><p class='mo_ldap_pricing-rate'><sup>$</sup> 249 <sup>*</sup></p>")) , Markup::create(t('<br><h2>PREMIUM</h2><p class="mo_ldap_pricing-rate"><sup>$</sup> 399 <sup>*</sup></p>')), Markup::create(t('<br><h2>All-Inclusive</h2><p class="mo_ldap_pricing-rate"><sup>$</sup> 649 <sup>*</sup></p>')),],

          [ '', Markup::create(t('<br><br><br><span class="button button--small">Current Plan</span>')),$standard , $premium, $allincluisve],

          [ Markup::create(t($this->tooltips("Unlimited Authentication via LDAP"))),              Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t($this->tooltips("LDAP Directory Configuration"))),              Markup::create(t('Single')), Markup::create(t('Single')), Markup::create(t('Single')), Markup::create(t('Multiple')), ],
          [ Markup::create(t($this->tooltips('Search user in LDAP (search filter)'))),              Markup::create(t('Single attribute')), Markup::create(t('Single attribute')), Markup::create(t('Multiple attributes')), Markup::create(t('Multiple attributes')), ],
          [ Markup::create(t($this->tooltips('Search users under Search Base (like DC,OU)'))),              Markup::create(t('Single Search Base')), Markup::create(t('Single Search Base')), Markup::create(t('Multiple Search Bases')), Markup::create(t('Multiple Search Bases')), ],
          [ Markup::create(t($this->tooltips("Attribute Mapping"))),              Markup::create(t('Only email mapping')), Markup::create(t('Custom Mapping')), Markup::create(t('Custom Mapping')), Markup::create(t('Custom Mapping')), ],

          [ Markup::create(t($this->tooltips('Auto Create Users in Drupal'))),              Markup::create(t('')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t($this->tooltips('Role Mapping'))),              Markup::create(t('')), Markup::create(t('Only default role')), Markup::create(t('Advanced')), Markup::create(t('Advanced')), ],
          [ Markup::create(t($this->tooltips('TLS Connection'))),              Markup::create(t('')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t($this->tooltips('Support for Custom Integration'))),              Markup::create(t('')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), ],

          [ Markup::create(t($this->tooltips('NTLM & Kerberos Authentication'))),              Markup::create(t('')), Markup::create(t('')), Markup::create(t('&#x2714;')), Markup::create(t('&#x2714;')), ],

          [ Markup::create(t($this->tooltips('Group mapping'))),              Markup::create(t('')), Markup::create(t('')), Markup::create(t('')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t($this->tooltips('Redirect user after login and logout'))),              Markup::create(t('')), Markup::create(t('')), Markup::create(t('')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t($this->tooltips('Page Restriction'))),              Markup::create(t('')), Markup::create(t('')), Markup::create(t('')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t('<span style="color: red;font-size:large;font-weight: bolder">*</span><b>'.$this->tooltips("Import users from LDAP server").'</b>')),              Markup::create(t('')), Markup::create(t('')), Markup::create(t('')), Markup::create(t('&#x2714;')), ],
          [ Markup::create(t('<span style="color: red;font-size:large;font-weight: bolder">*</span><b>'.$this->tooltips("Password and Directory Sync").'</b>')),              Markup::create(t('')), Markup::create(t('')), Markup::create(t('')), Markup::create(t('&#x2714;')), ],
      ];

    $form['ldap_upgrade_tab'] = [
        '#type' => 'table',
        '#responsive' => TRUE,
        '#rows' => $features,
        '#size' => 5,
        '#attributes' => ['class' => 'mo_upgrade_plans_features'],
        '#suffix' => '<br>'
    ];

    $form['instance_info'] = [
        '#type' => 'details',
        "#title" => $this->t("<b>WHAT IS INSTANCE ?</b>"),
        '#open' => TRUE,
    ];

    $form['instance_info']['explanation'] = [
          '#markup' => $this->t("A Drupal instance refers to a single installation of a Drupal site. It refers to each individual website where the module is activated. In the case of multisite/subsite Drupal setup, each site with a separate database will be counted as a single instance. For eg. If you have the dev-staging-prod type of environment then you will require 3 licenses of the module (with additional discounts applicable on pre-production environments). Contact us at <a href='mailto:drupalsupport@xecurify.com'>drupalsupport@xecurify.com</a> for bulk discounts.")
      ];

    $form['upgrade_steps'] = [
        '#type' => 'details',
        '#title' => $this->t('<b>HOW TO UPGRADE TO THE LICENSED VERSION OF THE MODULE ?</b>'),
        '#open' => TRUE,
    ];

    $form['upgrade_steps']['steps'] = [
          '#markup' => '<div class="row">
   <div class="col-md-6">
     <div class="upgrade_step"><div class="upgrade_steps_wise">1</div> Click on Upgrade Now button for required licensed version plan and you will be redirected to miniOrange login console.</div>
     <div class="upgrade_step"><div class="upgrade_steps_wise">2</div> Enter your username and password with which you have created an account with us. After that you will be redirected to payment page.</div>
     <div class="upgrade_step"><div class="upgrade_steps_wise">3</div> Enter your card details and proceed for payment. On successful payment completion, the licensed version will be available for download.</div>
   </div>
   <div class="col-md-6">
        <div class="upgrade_step"><div class="upgrade_steps_wise">4</div> Download the licensed version module from under the Releases and Downloads section.</div>
    <div class="upgrade_step"><div class="upgrade_steps_wise">5</div> Uninstall and then delete the free version of the module from your Drupal site. Now install the downloaded latest version of the module</div>
   </div>
  </div>',
      ];


    $form['quote_request_1'] = [
          '#type' => 'details',
          '#title' => $this->t("<h5><b>Request Quote</b></h5>"),
          '#open' => TRUE,
    ];

    $form['quote_request_1']['miniorange_ldap_email'] = [
          '#type' => 'textfield',
          '#default_value' => Utilities::getCustomerEmail(),
          '#title' => t('Email:'),
          '#attributes' => ['placeholder' => 'name@example.com','style' => 'max-width : 42%;'],
          '#required' => TRUE,
      ];

    $form['quote_request_1']["miniorange_ldap_number_of_instances"] = [
          "#type" => "select",
          "#title" => t("Select the number of instances: "),
          "#options" => ['1' => t('1'), '2' => t('2'), '3' => t('3'), '4' => t('4'), '5' => t('5'), '6' => t('6'), '7' => t('7'), '8' => t('8'), '9' => t('9'), '10' => t('10'), '15' => t('15'), '20' => t('20'), '30' => t('30'), '40' => t('40'), '50' => t('50')],
        '#attributes' => ['style' => 'max-width : 42%;']
    ];

    $form['quote_request_1']["foobar_options"]["miniorange_ldap_plan_select"] = [
          "#type" => "select",
          "#title" => t("Select your plan:"),
          "#options" => [
              "Standard" => t("Standard"),
              "Premium" => t("Premium"),
              "All-Inclusive" => t("All-Inclusive"),
              "Not-Sure" => t("Not-Sure (We will help you)"),
          ],
        '#attributes' => ['style' => 'max-width : 42%;']
      ];

    $form['quote_request_1']['miniorange_ldap_support_comment'] = [
          '#type' => 'textarea',
          '#title' => t('Comments'),
          '#cols' => '10',
          '#rows' => '5',
          '#attributes' => ['style' => 'width:42%;height:80px;', 'placeholder' => 'Write your query here'],
          '#required' => TRUE,
      ];
    $form['quote_request_1']['miniorange_ldap_support_submit'] = [
          '#type' => 'submit',
          '#value' => t('Submit Query'),
          '#submit' => ['::saved_request_quote'],
      ];


    $form['payment_methods'] = [
        '#type' => 'details',
        '#title' => $this->t('PAYMENT METHODS'),
        '#open' => TRUE,
    ];

      $form['payment_methods']['all_methods'] = [
          '#markup' => '<div class="row">
        <div class="col-md-3 payment_method_inner_divs">
            <br><div><img src="' . $base_url . '/' . $module_path . '/resources/card_payment.png" width="120" ><h4>Card Payment</h4></div><hr>
            <p>If the payment is made through Credit Card/International Debit Card, the license will be created automatically once the payment is completed.</p>
        </div>
        <div class="col-md-3 payment_method_inner_divs">
            <br><div><img src="' . $base_url . '/' . $module_path . '/resources/paypal.png" class="payment_img" width="120"><h4>PayPal</h4></div><hr>
            <p>Use the following PayPal ID <a href="mailto:info@xecurify.com">info@xecurify.com</a> for making the payment via PayPal.</p>
        </div>
        <div class="col-md-3 payment_method_inner_divs">
            <br><div><img src="' . $base_url . '/' . $module_path . '/resources/bank_transfer.png" width="150" ><h4>Bank Transfer</h4></div><hr>
            <p>If you want to use bank transfer for the payment then contact us at <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a> so that we can provide you the bank details.</p>
        </div>
    </div>',
          '#suffix' => '</div><div>'
      ];

    return $form;
  }

  /**
   *
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {

  }

  public function tooltips($feature){

    $feature_name = 'default';
    $feature_description = 'default';

    switch ($feature) {

      case "Unlimited Authentication via LDAP" :
        $feature_name = 'Unlimited Authentication via LDAP' ;
        $feature_description = 'Login your existing Drupal user using their LDAP servers credentials.';
        break;

      case "LDAP Directory Configuration" :
        $feature_name = 'LDAP Directory Configuration' ;
        $feature_description = 'You can configure the single LDAP server in the module. Multiple LDAP server is supported in ALL-Incluisve version of the module.';
        break;

      case "Search user in LDAP (search filter)" :
        $feature_name = 'Search user in LDAP (search filter)';
        $feature_description = 'Search filters enable you to define search criteria and provide more efficient and effective searches. Search with multiple attributes are present in the paid version of the module.';
        break;

      case "Search users under Search Base (like DC,OU)" :
        $feature_name = 'Search users under Search Base (like DC,OU)';
        $feature_description = 'Search Base denotes the location in the directory where the search for a particular directory object begins. If you want to search your users at multiple location (OUs and DCs) then you will require multiple Search Bases.' ;
        break;

      case "Attribute Mapping" :
        $feature_name = 'Attribute Mapping';
        $feature_description = 'This feature allows you to map your LDAP users information to the Drupal site users. Like you can map the email, sn(last name), cn(common name) to the Drupal custom fields.';
        break;
      case "Support for Custom Integration" :
        $feature_name = 'Support for Custom Integration';
        $feature_description = 'We can provide you the customization according to your use case.';
        break;
      case "Auto Create Users in Drupal" :
        $feature_name = 'Auto Create Users in Drupal';
        $feature_description = 'This feature allows for automatic creation of users on your Drupal site when a user attempts to log in using their LDAP server credentials and the user does not already exist on your Drupal site.';
        break;

      case "Role Mapping" :
        $feature_name = 'Role Mapping';
        $feature_description = 'This feature allows you to assign the Drupal roles to your users on the basis of their LDAP Group or OU.';
        break;

      case "TLS Connection" :
        $feature_name = 'TLS Connection';
        $feature_description = 'TLS Connection';
        break;

      case "NTLM & Kerberos Authentication" :
        $feature_name = 'NTLM & Kerberos Authentication';
        $feature_description = 'This feature allows your user to login your drupal site using the NTLM and Kerberos Authentication protocol.';
        break;

      case "Group mapping" :
        $feature_name = 'Group mapping';
        $feature_description = 'This feature allows you to assign the Drupal groups to your users on the basis of their LDAP Group or OU.';
        break;

      case "Redirect user after login and logout" :
        $feature_name = 'Redirect user after login and logout';
        $feature_description = 'This feature allows you to redirect your user on the certain page or some custom url after successfully login and logout.';
        break;

      case "Page Restriction" :
        $feature_name = 'Page Restriction';
        $feature_description = 'This feature allows you to restrict your drupal site pages/nodes on the basis of the users LDAP Group or OU.';
        break;

      case "Import users from LDAP server" :
        $feature_name = 'Import users from LDAP server';
        $feature_description = 'This feature allows you to import all your users present on the LDAP server with considering the Attribute mapping and Role mapping configurations.';
        break;

      case "Password and Directory Sync" :
        $feature_name = 'Password and Directory Sync';
        $feature_description = 'This features allows you to sync your LDAP users with the Drupal site. If user is created/updated on your Drupal site then the user will automatically gets created/updated on the LDAP server and vice versa. Similarly the users Attribute and Roles will also get sync.';
        break;

      default :
        $feature_name = 'default';
        $feature_description = 'default';
    }

    return "<span data-toggle= 'tooltip' data-placement='top' data-html='true'  title= '$feature_description' >$feature_name</span>";
  }

  /**
   *
   */
  public function saved_support(array &$form, FormStateInterface $form_state) {
    $email = $form['miniorange_ldap_email']['#value'];
    $instances = $form['miniorange_ldap_number_of_instances']['#value'];
    $planname = $form["foobar_options"]['miniorange_ldap_plan_select']['#value'];
    $query = $form['miniorange_ldap_support_comment']['#value'];
    $query = $query . '<br> No of Instances <br>' . $instances . '&nsbp Plan <br>' . $planname;
    Utilities::send_support_query($email, '', $query);
  }

  /**
   *
   */
  public static function saved_request_quote(array &$form, FormStateInterface $form_state) {

    $email = trim($form_state->getValue('miniorange_ldap_email'));

      if (!\Drupal::service('email.validator')->isValid($email)) {
      Utilities::add_message(t('The email address <b><i>' . $email . '</i></b> is not valid.'), 'error');
      return;
    }

    $instances = $form_state->getValue('miniorange_ldap_number_of_instances');//$form['miniorange_ldap_number_of_instances']['#value'];
    $planname = $form_state->getValue('miniorange_ldap_plan_select');//trim($form["foobar_options"]['miniorange_ldap_plan_select']['#value']);
    $query1 = trim($form_state->getValue('miniorange_ldap_support_comment'));//trim($form['miniorange_ldap_support_comment']['#value']);
    $query = $query1 . '<br> No of Instances: ' . $instances . '<br> Plan: ' . $planname;

    if (empty($email) || empty($query)) {
      Utilities::add_message(t('The <b><u>Email</u></b> and <b><u>Query</u></b> fields are mandatory.'), 'error');
      return;
    }

    $support = new MiniorangeLdapSupport($email, '', $query, 'request_quote');
    $support_response = $support->sendSupportQuery();

    if ($support_response) {
      Utilities::add_message(t("Request successfully sent. We will get back to you shortly at <b>$email</b>."), 'status');
    }
    else {
      Utilities::add_message(t('Error sending request.'), 'error');
    }
  }

}
